Private R,C,D,U,J,L As Integer

Sub Main
	Begin Dialog UserDialog 310,203,"Super Duper Part Renumberer",.DialogFunc ' %GRID:10,7,1,1
		Text 100,35,120,14,"Resistors",.res4
		Text 100,98,120,14,"connectors (J)",.cons
		Text 100,119,120,14,"LEDs/Diodes (D)",.led_dio
		Text 100,140,120,14,"Inductors",.ind
		CheckBox 60,35,20,14,"res",.res_chk
		Text 10,10,180,15,"Select parts to renumber:"
		OKButton 70,168,60,21
		CheckBox 60,56,20,14,"cap",.cap_chk
		CheckBox 60,98,20,14,"con",.con_chk
		CheckBox 60,77,20,14,"ic",.ic_chk
		CheckBox 60,119,20,14,"d",.d_chk
		CheckBox 60,140,20,14,"ind",.ind_chk
		Text 100,77,120,14,"IC's (U)",.ic
		Text 100,56,120,14,"Capacitors",.cap
	End Dialog
    Dim dlg As UserDialog
    Debug.Print Dialog(dlg)

	Debug.Print "R: " & R & vbCrLf & _
				"C: " & C & vbCrLf & _
				"L: " & L & vbCrLf & _
				"U: " & U & vbCrLf & _
				"D: " & D & vbCrLf & _
				"J: " & J
				
	renumber()
	
End Sub
Function DialogFunc%(DlgItem$, Action%, SuppValue%)
    Debug.Print "Action=";Action%
   ' Debug.Print DlgItem$;"=""";DlgText$(DlgItem$);""""
    Debug.Print "SuppValue=";SuppValue%
    Select Case Action%
    Case 1 ' Dialog box initialization
        Beep
    Case 2 ' Value changing or button pressed
    
    	'each checkbox sets the renaming flag for that part type which is then 
    	'queried during the renaming process. If the flag is set (1) renaming is allowed
    	'otherwise the part is not modified.    	
    	
        Select Case LCase(DlgItem$)
        	
        	'bit 0
        	Case "res_chk"
        		R = SuppValue%
        		Debug.Print R
        	'bit 1
        	Case "cap_chk"
        		C = SuppValue%
        		Debug.Print C
        	'bit 2
        	Case "ind_chk"
        		L = SuppValue%
        		Debug.Print L
        	'bit 3
        	Case "ic_chk"
        		U = SuppValue%
        		Debug.Print U
        	'bit 4
        	Case "con_chk"
        		J = SuppValue%
        		Debug.Print J
        	'bit 5
        	Case "d_chk"
        		D = SuppValue%
        		Debug.Print D
        End Select
        	
    Case 4 ' Focus changed
        Debug.Print "DlgFocus=""";DlgFocus();""""
    Case 6 ' Function key
        If SuppValue And &H100 Then Debug.Print "Shift-";
        If SuppValue And &H200 Then Debug.Print "Ctrl-";
        If SuppValue And &H400 Then Debug.Print "Alt-";
        Debug.Print "F" & (SuppValue And &HFF)
    End Select
End Function
Function renumber()

	Dim rcount As Integer
	Dim ccount As Integer
	Dim ucount As Integer
	Dim lcount As Integer
	Dim jcount As Integer
	Dim dcount As Integer
	Dim this_name As String
	Dim num_sheets As Integer
	
	num_sheets = ActiveDocument.Sheets.Count
	Set objs = ActiveDocument.GetObjects(,,True)

	For aSheet = 1 To num_sheets
	
		ActiveDocument.Sheets(aSheet).Activate
		Set comps = ActiveDocument.ActiveSheet.Components
		
		Debug.Print "sheet #" & aSheet & ", components found: " & comps.Count
		
		For i = 1 To comps.Count Step 1
			this_name = comps.Item(i).Name
			Debug.Print "original name: " & this_name & " -> ";
			
			new_ref_num = Trim(Str(Val(Mid(this_name,2,4))+9000))
			new_name = Mid(this_name,1,1) & new_ref_num
			pre = UCase(Mid(this_name,1,1))
			
			'don't rename some components such as mounting holes, vias, etc...
			If pre = "R" Or pre = "C" Or pre = "L" Or pre = "U" Or pre = "D" Or pre = "J" Then
				If Val(Mid(this_name,2,5)) < 9000 Then
					Let comps.Item(i).Name = new_name
					Debug.Print "new name:" & new_name
				Else
					Debug.Print "already renamed"
				End If
			Else
				Debug.Print "skipped"
			End If
				
		Next i
		
	Next aSheet
	
	For aSheet = 1 To num_sheets
	
		ActiveDocument.Sheets(aSheet).Activate
		Set comps = ActiveDocument.ActiveSheet.Components
	
		For i = 1 To comps.Count Step 1
		
			this_name = comps.Item(i).Name
		
			Select Case UCase((Mid(this_name,1,1)))
				Case "R"
					rcount = rcount +1
					new_name = Mid(this_name,1,1) & rcount
					Let comps.Item(i).Name = new_name
				Case "C" 
					ccount = ccount + 1
					new_name = Mid(this_name,1,1) & ccount
					Let comps.Item(i).Name = new_name
				Case "U"
					ucount = ucount + 1
					new_name = Mid(this_name,1,1) & ucount
					Let comps.Item(i).Name = new_name
				Case "L"
					lcount = lcount + 1
					new_name = Mid(this_name,1,1) & lcount
					Let comps.Item(i).Name = new_name
				Case "D"
					dcount = dcount + 1
					new_name = Mid(this_name,1,1) & dcount
					Let comps.Item(i).Name = new_name
				Case "J"
					jcount = jcount + 1
					new_name = Mid(this_name,1,1) & jcount
					Let comps.Item(i).Name = new_name
				End Select
				
		Next i
	
	Next aSheet
	
	ActiveDocument.ActiveView.Refresh


End Function
